#include <Stepper.h>

/* Variables to Change */
int deg = 18; /* How many degrees to step */
int pin1 = 3; /* Stepper pin 1 */
int pin2 = 4; /* Stepper pin 2 */
int pin3 = 5; /* Stepper pin 3 */
int pin4 = 6; /* Stepper pin 4 */
int remotePin = 13; /* Camera remote pin. 13 is best, it has a resistor */
int continuePin = 10; /* Pin for "Continue" button */
int totalSteps = 200; /* Number of steps that your motor has */
int autoFocusTime = 2000; /* Delay for Autofocus, Set based on the light level and flash usage */
/* End Variables to Change */



int steps = deg / 1.8;
 Stepper stepper(totalSteps, pin1, pin2, pin3, pin4);
int rotSteps = 0;
int done = 0;



void setup(){
  Serial.begin(9600);
  stepper.setSpeed(5);
  pinMode(remotePin, OUTPUT);
  digitalWrite(remotePin,LOW); //turn on an LED for debugging
  pinMode(continuePin, INPUT); // Set button pin to input
  digitalWrite(continuePin, HIGH); // Turn on internal pullup resistor
  
}


// Function to take a photo via remote (autofocus, then shoot)
void takePhoto(){
  digitalWrite(remotePin,HIGH);
  delay(autoFocusTime);
  digitalWrite(remotePin,LOW);
  delay(100);
  digitalWrite(remotePin,HIGH);
  delay(500);
  digitalWrite(remotePin,LOW);
  delay(autoFocusTime); /* Time to take the photo, avoids blur. Tweak me! */
}


void loop(){
  Serial.println("Done:");
  Serial.println(done);
  Serial.println("PinStatus:");
  Serial.println(digitalRead(continuePin));

  if(done == 1){
     Serial.println("Im Waiting...");
     delay(500); 
     if(digitalRead(continuePin) == 0) {
      done = 0; 
      rotSteps = 0;
      Serial.println("Thanks");
     }
  }
  else{
     takePhoto();
     stepper.step(steps);
     rotSteps += steps;
       if(rotSteps == totalSteps){
         stepper.step(-totalSteps); 
         rotSteps = 0;
         done = 1;
       }   
  }
}
